<?php

//************************************
// delete unused images in a photo album
//************************************

include "includes/getDocumentRoot.inc.php";

// global variables
$site = "";
$dir = "";
$message = "";

ini_set("always_populate_raw_post_data", true);

// The handler for the XML element opening tags
function startElementHandler($parser, $name, $attr) {
	global $dir, $site, $message;

	// TODO: we also need the full path, so we can set the path, such as "content/sitename/merchants/maps/" for saving the map
	if (strcmp($name, "PHOTOALBUMIMAGES") == 0) {
		$dir = $attr["DIR"];
		$site = $attr["SITE"];
	} else if (strcmp($name, "IMAGE") == 0) {
		if ($site == "" || $dir == "") {
			echo "<response><status>Error, invalid values send to the server for deleting images.</status></response>";
			exit;
		}

		$name = $attr["NAME"];				
		$photoAlbumImage = getDocumentRoot() . $site . "/photoAlbums/" . $dir . "/" . $name;
		if (is_file($photoAlbumImage)) {

			// delete the image
			$delResult = unlink($photoAlbumImage);
			if (!$delResult) {
				if ($message == "") {
					$message = "Error deleting the image(s): " . $name;
				} else {
					$message .= ", " . $name;
				}
			}
		}
	}
}

// The handler for the XML element closing tags
function endElementHandler () {
	// nothing to do in this case
}

// create our XML parser
$parser = xml_parser_create();

// register the start and end element handlers
xml_set_element_handler($parser, "startElementHandler", "endElementHandler");


if (!xml_parse($parser, $HTTP_RAW_POST_DATA, true)) {
	// return XML document with an error message
	$message = "There was an error in the XML line " .
				xml_get_current_line_number($parser) . " at position " .
				xml_get_current_column_number($parser);
	echo "<response><status>". $message ."</status></response>";
	exit;
}

// finished parsing the XML
xml_parser_free($parser);

if ($message != "") {
	$message .= ".";
	echo "<response><status>" . $message . "</status></response>";
} else {
	echo "<response><status>success</status></response>";
}
?>